/////////////////////////////////////////////////////////////////////////////
//	Psytec QR Code Decode Library [Ver.1.57 2015/08/24]
//  PsyQrDcd.h
//	DLL C|[gpt@C
//	(C) 2003-2015 Psytec Inc.
//	URL:www.psytec.co.jp
/////////////////////////////////////////////////////////////////////////////

using namespace System;
using namespace System::Runtime::InteropServices;

// G[R[h`
#define QRD_ERROR_SYMBLE_NOT_FOUND	 0
#define QRD_ERROR_FILE_NOT_FOUND	-1
#define QRD_ERROR_READ_FAULT		-2
#define QRD_ERROR_BAD_FORMAT		-3
#define QRD_ERROR_SHARING_VIOLATION	-4
#define QRD_ERROR_NOT_ENOUGH_MEMORY	-5

namespace PsyQrDcd
{
	/////////////////////////////////////////////////////////////////////////
	// DecodePictureFile - 摜t@C̃fR[h
	//   F摜t@CpX(BMPAJPEGAGIFAPINGATIFF`)
	// ߂lFfR[hꂽV{A܂͏LG[R[h

	[DllImport("PsyQrDcd.dll")]
	extern "C" int DecodePictureFile(String^ lpszFilePath);


	/////////////////////////////////////////////////////////////////////////
	// DecodePictureFileRect - 摜t@C̃fR[hifR[h͈͎wj
	//   F摜t@CpX(BMPAJPEGAGIFAPINGATIFF`)AfR[h͈͍WiA゙AEAj
	// ߂lFfR[hꂽV{A܂͏LG[R[h
	//   lFW͉摜Ŝ̍_ƂsNZPʂŎw肵ĂB

	[DllImport("PsyQrDcd.dll")]
	extern "C" int DecodePictureFileRect(String^ lpszFilePath, int nLeftX, int nTopY, int nRightX, int nBottomY);


	/////////////////////////////////////////////////////////////////////////
	// DecodeGrayScaleArray - O[XP[(256K)f[^̃fR[h
	//   FO[XP[f[^z̉摜f[^(BYTE^)A摜A摜
	// ߂lFfR[hꂽV{A܂ QRD_ERROR_SYMBLE_NOT_FOUND, QRD_ERROR_NOT_ENOUGH_MEMORY
	//   lF摜f[^͍艡A1sNZɂ1oCgA256KA0= 255=

	[DllImport("PsyQrDcd.dll")]
	extern "C" int DecodeGrayScaleArray(Byte* lpbyData, int nWidth, int nHeight);


	/////////////////////////////////////////////////////////////////////////
	// DecodeBinaryArray - oCi(2l)f[^̃fR[h
	//   FoCif[^z̉摜f[^(BYTE^)A摜A摜
	// ߂lFfR[hꂽV{A܂ QRD_ERROR_SYMBLE_NOT_FOUND, QRD_ERROR_NOT_ENOUGH_MEMORY
	//   lF摜f[^͍艡A1sNZɂ1oCgA2lA=FALSE(0) =TRUE(0ȊO)

	[DllImport("PsyQrDcd.dll")]
	extern "C" int DecodeBinaryArray(Byte* lpbyData, int nWidth, int nHeight);


	/////////////////////////////////////////////////////////////////////////
	// GetDecodeData - fR[hʃf[^擾
	//   Ff[^CfbNX(0)Af[^󂯎obt@AhX
	// ߂lFf[^(oCg)A-1=f[^CfbNXs
	//   lFf[^I[ɂ'\0'tĂ܂B(߂l̒ɂ'\0'͊܂܂Ă܂B)
	//		   Ăяo lplpsBuff̒lɂ蓮삪قȂ܂B
	//		   =null  Ńobt@OĂf[^̃AhXlplpsBuffɑ܂B
	//		   !=null  w肳ꂽAhXɃobt@OĂf[^Rs[܂B

	[DllImport("PsyQrDcd.dll")]
	extern "C" int GetDecodeData(int nIndex, IntPtr* lplpBuff);


	/////////////////////////////////////////////////////////////////////////
	// GetDecodeVersion - fR[hV{̌^Ԏ擾
	//   Ff[^CfbNX(0)
	// ߂lF^(1`40)A-1=f[^CfbNXs

	[DllImport("PsyQrDcd.dll")]
	extern "C" int GetDecodeVersion(int nIndex);


	/////////////////////////////////////////////////////////////////////////
	// GetDecodeLevel - fR[hV{̌x擾
	//   Ff[^CfbNX(0)
	// ߂lFx(0=L, 1=M, 2=Q, 3=H)A-1=f[^CfbNXs

	[DllImport("PsyQrDcd.dll")]
	extern "C" int GetDecodeLevel(int nIndex);


	/////////////////////////////////////////////////////////////////////////
	// GetDecodeMaskingNo - fR[hV{̃}XLOp^[ԍ擾
	//   Ff[^CfbNX(0)
	// ߂lF}XLOp^[ԍ(0`7)A-1=f[^CfbNXs

	[DllImport("PsyQrDcd.dll")]
	extern "C" int GetDecodeMaskingNo(int nIndex);


	/////////////////////////////////////////////////////////////////////////
	// GetConcatenationInfo - fR[hV{̘A擾
	//   Ff[^CfbNX(0)AAV[PX(|C^)AA`FbNfWbg(|C^)
	// ߂lFf[^A(1`16)A0=Af[^A-1=f[^CfbNXs

	[DllImport("PsyQrDcd.dll")]
	extern "C" int GetConcatenationInfo(int nIndex, int* lpnSeqNo, Byte* lpbyCheckDigit);


	/////////////////////////////////////////////////////////////////////////
	// GetSymbolePosition - fR[hV{̈ʒu擾
	//   Ff[^CfbNX(0)AW󂯎z
	// ߂lF0=IA-1=f[^CfbNXs
	//   lFW󂯎źAԂ̃V{̍ォ玞v
	//		   [0]=゘A[1]=゙A[2]=E゘A[3]=E゙A[4]=EA[5]=EA[6]=A[7]=

	[DllImport("PsyQrDcd.dll")]
	extern "C" int GetSymbolePosition(int nIndex, int* nPositon);


	/////////////////////////////////////////////////////////////////////////
	// SetDecodeSymbolCount - fR[hV{̏ݒ
	//   FfR[hV{(1`32)A0=ǂݎ萬_̃xŏI(l)
	//   lFfR[hł͗lXȉ摜ɑΉ邽ߕ̉摜HsĂ܂B
	//		   0ݒ肵ꍇAꃌx̏œǂݎ邱ƂłV{͑Sēǂݎ܂B
	//		   1ȏ̐ݒł͏ɒBƏI܂AtɏɒB܂ŏI܂̂ŁA
	//		   ǂݗƂhꍇɂpB
	//		   ݒl̓vOI(DLLA[h)܂ŗLłB

	[DllImport("PsyQrDcd.dll")]
	extern "C" void SetDecodeSymbolCount(int nCount);


	/////////////////////////////////////////////////////////////////////////
	// SetDecodeEffectLevel - 摜x̐ݒ
	//   FfR[hx(0`3)Al=3
	//   lF0=łP2l̂ݍs܂B
	//		   1=ݒ0ɉmCYs܂B
	//		   2=ݒ0ɉ摜̕IȖÕ␳s܂B
	//		   3=ݒ1Ɛݒ2̗̏s܂B
	//		   ݒl̓vOI(DLLA[h)܂ŗLłB

	[DllImport("PsyQrDcd.dll")]
	extern "C" void SetDecodeEffectLevel(int nLevel);


	/////////////////////////////////////////////////////////////////////////
	// SetBrightnessBorder - 摜Âlݒ
	//   FÂl(0`255)A0=ݒ(l)
	//   lFݒ莞ɂ͉摜Ŝōł邢_ƈÂ_̒ԒllƂĂ܂B
	//		   V{ȊỎ摜܂܂ĂāAl߂ȂꍇȂǂɐݒ肵ĂB
	//		   ݒl̓vOI(DLLA[h)܂ŗLłB

	[DllImport("PsyQrDcd.dll")]
	extern "C" void SetBrightnessBorder(Byte byBorder);


	/////////////////////////////////////////////////////////////////////////
	// SetMinimumModuleSize - V{ŏW[Pʐݒ
	//   FW[TCY(1`255)Al=1
	//   lFW[̑傫ȃV{FꍇAK؂Ȓlݒ肷邱Ƃŏł܂B
	//		   ݒl̓vOI(DLLA[h)܂ŗLłB

	[DllImport("PsyQrDcd.dll")]
	extern "C" void SetMinimumModuleSize(Byte bySize);


	/////////////////////////////////////////////////////////////////////////
	// FreeAllocateMemory - fR[hʕۑ̊J
	//   lFfR[hʂ̃f[^V{ۑĂ郁J܂B
	//		   ̉̓fR[hw֐̌ĂяoDLLA[hɂIɍs܂B

	[DllImport("PsyQrDcd.dll")]
	extern "C" void FreeAllocateMemory();


	/////////////////////////////////////////////////////////////////////////
	// FreeAllocateMemory - ǂݎG[ڍ׏擾
	//   lFfR[hʂ̃f[^V{ۑĂ郁J܂B
	// ߂lF0=G[ȂA1=ʒuop^[oA2=ʒuop^[̃V{osA3=f[^ǂݎ莸s

	[DllImport("PsyQrDcd.dll")]
	extern "C" int GetErrorLevel();
}
